
unit UnDraw;
//   ,    
//      .
//     "  #1".
// (C) Semyonov Eugene, Fwcs Corporation, 02/12/2001.


//  .
interface
  uses  UnDefin;

  procedure StatusBr(s_in:String); //     .
  procedure wlOtchet(s:String);    //   s   .
  function  FunStr(f:Extended; n,m:Integer):String; //   f   :n:m
  function  FunVal(s:String):Extended;     //   s   .
  function  GetScrnX(x:Extended):Integer;  // . . X   x.
  function  GetScrnY(y:Extended):Integer;  // . . Y   y.
  procedure DiColMap;  //     .
  procedure DrMinPoi;  //  ""  .
  procedure Iterat; // ,     .
  function  FunValIJ(j,i:Integer):Extended; // .   .
  procedure CalcAlFn; //      .  .
  procedure DrColMap(met:Integer); //    .
  procedure DrLinLev(met:Integer); //   .

const
  fclScore=21;         //    
  fclLnLvI=10;         //     ()
  fclLnLvP=11;         //     ()
  fclWgrMi=12;         //      
  fclWgrMa=13;         //     
  fclTracI=14;         //     ()
  fclTracP=15;         //     ()
  fclContL=16;         //    
  fclAxisC=17;         //    
  fclGridB=18;         //    
  fclGridS=19;         //    
  fclTextI=20;         //      ()
  fclTextP=21;         //      ()

var
  xmin, xmax, ymin, ymax : Extended;
  zRmin, zRmax : Extended;             //   . 
  zXmin, zYmin : Integer;              //   
  MaxTrace, CurTrace : LongWord;       //    


//  .
implementation
uses  UnOptim1, UnGraph, UnMinim, UnGrid,  Graphics, SysUtils, Math;


//     .
procedure StatusBr(s_in:String);
begin
  fmMnForm.sbMessag.SimpleText:=s_in;
end;


//   s   .
procedure wlOtchet(s:String);
 begin
  fmMnForm.mmOtchet.Lines.Add(s);
 end;


//    f  
//    :n:m (:).
function FunStr(f:Extended; n,m:Integer):String;
 var
  s:String;
 begin
  Str(f:n:m,s);
  FunStr := s;
 end;


//   s   .
function  FunVal(s:String):Extended;
 var
  f:Extended;
  i:Integer;
 begin
  Val(s, f, i);
  FunVal := f;
 end;


//    X   x.
function GetScrnX(x:Extended):Integer;
var
  rxb,rxe:Extended;
begin
  with fmMnForm, pbDrawAr, Canvas do
   GetScrnX:=Floor( (x-xmin)*(Width-1)/(xmax-xmin) + 1 );
end;


//    Y   y.
function GetScrnY(y:Extended):Integer;
var
  ryb,rye:Extended;
begin
  with fmMnForm, pbDrawAr, Canvas do
   GetScrnY:=Floor( (y-ymax)*(Height-1)/(ymin-ymax) + 1 );
end;


//     .
procedure DiColMap;
var
  i,j,k:Integer;
begin
  with fmMnForm, pbColMap, Canvas do
   begin
    Pen.Color := DiColRGB[fclContL,0];
    i:=Width mod 10;

    for k:=0 to 9 do
     begin
      Brush.Color := ValDiRGB(k/1.0,0.0,9.0);
      i:=Round(k*(Width-1)/10);
      j:=Round((k+1)*(Width-1)/10)+1;
      Rectangle(i, 0, j, Height);
     end;
   end;  // with
end;


//  ""  .
procedure DrMinPoi;
begin
  with fmMnForm, pbDrawAr, Canvas do
   begin
    Pen.Color   := DiColRGB[fclTracI,0];
    MoveTo(zXmin-4,zYmin);  LineTo(zXmin+5,zYmin);
    MoveTo(zXmin,zYmin-4);  LineTo(zXmin,zYmin+5);
   end;  // with
end;


// ,     .
procedure Iterat;
var
  x0,y0,  xm,ym,zm:Extended;
  i:LongWord;
begin
  with fmMnForm, pbDrawAr, Canvas do
   begin
  {      }
    x0:=FunVal(meBeg_Xr.Text);  y0:=FunVal(meBeg_Yr.Text);
    eps:=FunVal(meCnsEps.Text);
    hst:=FunVal(meCnsHst.Text);
    Uoo:=FunVal(meCnsUoo.Text);
    CurTsk:=coEquat.ItemIndex;
    zm:=GradSkor(x0,y0, xm,ym, MaxTrace);     //  

  {   }
    fmMnForm.mmOtchet.Lines.Clear;  wlOtchet('');
    wlOtchet(' : x = '
             +FloatToStr(xmin)+' .. '+FloatToStr(xmax)+', y='
             +FloatToStr(ymin)+' .. '+FloatToStr(ymax) );
    wlOtchet(' : x0 = '
             +meBeg_Xr.Text+', y0 = '+meBeg_Yr.Text);
    wlOtchet(' : zmin = z( '
             +FloatToStr(xm)+', '+FloatToStr(ym)
             +' ) = '+FloatToStr(zm));
    wlOtchet('    '+IntToStr(MaxTrace)+' .');
    wlOtchet('');  wlOtchet(' :');
    for i:=1 to MaxTrace do                                      begin
      wlOtchet('#'+IntToStr(i)+': z( '+FloatToStr(Solut[i,1])
               +', '+FloatToStr(Solut[i,2])+' ) = '
               +FloatToStr(Jn[CurTsk](Solut[i,1],Solut[i,2])));  end;
   end;  // with
end;


//      .
//  : j=1..xScor; i=1..yScor
function FunValIJ(j,i:Integer):Extended;
var
  xr, yr : Extended;
begin
    xr := xmin+(j-1)*(xmax-xmin)/(xScor-1);
    yr := ymax+(i-1)*(ymin-ymax)/(yScor-1);
    FunValIJ := Fun(xr,yr);
end;  // FunValIJ


//        .
procedure CalcAlFn;
var
  i, j : Integer;
  xr, yr, zr : Extended;
begin
    zRmin:=1E9; zRmax:=-1E9;
    with fmMnForm do
     begin
      xmin:=FunVal(meSrXb.Text);  ymin:=FunVal(meSrYb.Text);
      xmax:=FunVal(meSrXe.Text);  ymax:=FunVal(meSrYe.Text);
     end;

    for i:=1 to yScor do
     begin
      StatusBr('  : '+FloatToStr(Int(100*i/yScor))+'%');
      for j:=1 to xScor do
       begin
        xr:=xmin+(j-1)*(xmax-xmin)/(xScor-1);
        yr:=ymax+(i-1)*(ymin-ymax)/(yScor-1);
        zr:=Fun(xr,yr);
        if (zRmax<zr) then zRmax:=zr;
        if (zRmin>zr) then begin zRmin:=zr; zXmin:=j; zYmin:=i; end;
//kill        zVal^[(i-1)*xScor+(j-1)]:=zr;
       end;
     end;
   if (zRmin=zRmax) then  begin
     zRmin:=zRmin-0.0001;  zRmax:=zRmax+0.0001;  end;

  flDraw:=True;      //   
end;  // CalcAlFn


//    .
procedure DrColMap(met:Integer);
var
  i,j:Integer;
  zr:Extended;
begin
  with fmMnForm, pbDrawAr, Canvas do
   begin
   //   .
    Pen.Color   := DiColRGB[fclContL,0];
    Brush.Color := DiColRGB[fclLnLvP,0];
    Rectangle(0, 0, Width, Height);

    for i:=1 to yScor do
     begin
      if (flStop) then Break;
      StatusBr('  : '+FloatToStr(Int(100*i/yScor))+'%');
      for j:=1 to xScor do
       begin
        zr:=FunValIJ(j,i);
        case met of
          0: Pixels[j,i]:=ValDiRGB(zr,zRmin,zRmax);
          1: Pixels[j,i]:=ValToRGB(zr,zRmin,zRmax);
        end; // case
       end;
     end;
   end;  // with
end;  // DrColMap


//   .
procedure DrLinLev(met:Integer);
var
  buf : Array[1..3,1..4096] of Byte;

//    -   .
  procedure llHeight;
   var
    i,j:Integer;
    zr:Extended;
   begin
    with fmMnForm, pbDrawAr, Canvas do
     begin
      for i:=1 to yScor do
       begin
        if (flStop) then Break;
        StatusBr('  : '+FloatToStr(Int(100*i/yScor))+'%');
        for j:=1 to xScor do
         begin
          if ( (Pixels[j,i]<>Pixels[j+1,i  ]) or
               (Pixels[j,i]<>Pixels[j  ,i+1]) or
               (Pixels[j,i]<>Pixels[j+1,i+1]) )
           then  Pixels[j,i]:=DiColRGB[fclLnLvI,0]
           else  if (cbTrnpLL.Checked=False) then
                    Pixels[j,i]:=DiColRGB[fclLnLvP,0];
         end;
       end;  // i=1..yScor
    end;  // with
  end;  // llHeight

//    -  .
  procedure llThresh;
   var
    i,j:Integer;
    zr:Extended;
    stLL,wdLL:Extended;
   begin
    with fmMnForm, pbDrawAr, Canvas do
     begin
      stLL:=FunVal(meStLeLi.Text);
      wdLL:=FunVal(meWdLeLi.Text);
      for i:=1 to yScor do
       begin
        StatusBr('  : '+FloatToStr(Int(100*i/yScor))+'%');
        for j:=1 to xScor do
         begin
          zr:=FunValIJ(j,i);
          if ( (abs(zr*stLL-Round(zr*stLL))<wdLL) )
           then Pixels[j,i]:=DiColRGB[fclLnLvI,0]
           else  if (cbTrnpLL.Checked=False) then
                    Pixels[j,i]:=DiColRGB[fclLnLvP,0];
         end;
       end;  // i=1..yScor
    end;  // with
  end;  // llThresh

//    -  .
begin
    case met of
      0: llHeight;
      1: llThresh;
     end;
end;  // DrLinLev

end.

