unit UnGrid;
//     
//     .
//   . " ".
// (C) Semyonov Eugene, Fwcs Corporation, 04/12/2001.


//  .
interface
  procedure FwcsDrawGrid(fSmall, fBig, fAxis, fNumb: Boolean);
  procedure IniDrawPar;

var
  SrXb, SrYb: Extended;        //   - .
  SrXe, SrYe: Extended;        //   - .
  SrXc, SrYc: Extended;        //   . .
  SrXs, SrYs: Extended;        //   .
  SrXl, SrYl: Extended;        //     .
  SgXb, SgYb: Integer;         //   - .
  SgXe, SgYe: Integer;         //   - .
  SgXs, SgYs: Integer;         // -   .
  SgXl, SgYl: Integer;         //     .


//  .
implementation
uses UnOptim1, UnDraw, UnGraph,  SysUtils, Graphics;


//   .
//  -   :
//   fSmall -  ,
//   fBig   -  ,
//   fAxis  -  ,
//   fNumb  -  .
procedure FwcsDrawGrid(fSmall, fBig, fAxis, fNumb: Boolean);
var
  z0,z1: Extended;
  sx,sy: Integer;
  xn,yn: Integer;
  xw,yw: Integer;
begin
  IniDrawPar;
  with fmMnForm, pbDrawAr, Canvas do
   begin
   //   .

   //  .
    if (fSmall=True) then  begin
      Pen.Color := DiColRGB[fclGridS,0];

      z0:=SrXs/SgXs;
      z1:=z0*Trunc(SrXb/z0);
      while (z1<SrXe) do
       begin
        MoveTo(GetScrnX(z1), SgYb);  LineTo(GetScrnX(z1), SgYe);
        z1:=z1+z0;
       end;

      z0:=SrYs/SgYs;
      z1:=z0*Trunc(SrYb/z0);
      while (z1<SrYe) do
       begin
        MoveTo(SgXb, GetScrnY(z1));  LineTo(SgXe, GetScrnY(z1));
        z1:=z1+z0;
       end;
                           end;

   //  .
    if (fBig=True) then  begin
      Pen.Color := DiColRGB[fclGridB,0];

      z1:=SrXs*Trunc(SrXb/SrXs);
      while (z1<SrXe) do
       begin
        MoveTo(GetScrnX(z1), SgYb);  LineTo(GetScrnX(z1), SgYe);
        z1:=z1+SrXs;
       end;

      z1:=SrYs*Trunc(SrYb/SrYs);
      while (z1<SrYe) do
       begin
        MoveTo(SgXb, GetScrnY(z1));  LineTo(SgXe, GetScrnY(z1));
        z1:=z1+SrYs;
       end;
                         end;

   //  .
    if (fAxis=True) then  begin
      Pen.Color := DiColRGB[fclAxisC,0];

      if ( (SrXc>SrXb) and (SrXc<SrXe) ) then
       begin
        MoveTo(GetScrnX(SrXc), SgYb);  LineTo(GetScrnX(SrXc), SgYe);

        sx:=Width div 32;  sy:=Height div 16;
        MoveTo(GetScrnX(SrXc), SgYb);
        LineTo(GetScrnX(SrXc)-sx, SgYb+sy);
        MoveTo(GetScrnX(SrXc), SgYb);
        LineTo(GetScrnX(SrXc)+sx, SgYb+sy);
       end;

      if ( (SrYc>SrYb) and (SrYc<SrYe) ) then
       begin
        MoveTo(SgXb, GetScrnY(SrYc));  LineTo(SgXe, GetScrnY(SrYc));

        sx:=Width div 16;  sy:=Height div 32;
        MoveTo(SgXe, GetScrnY(SrYc));
        LineTo(SgXe-sx, GetScrnY(SrYc)-sy);
        MoveTo(SgXe, GetScrnY(SrYc));
        LineTo(SgXe-sx, GetScrnY(SrYc)+sy);
       end;
                          end;

   //  .
    if (fNumb=True) then
     begin
      Font.Color := DiColRGB[fclTextI,0];
      Brush.Color:= DiColRGB[fclTextP,0];
      xn:=-20648;             yn:=-20648;
      xw:=TextWidth('0.00');  yw:=TextHeight('0');
      if ((GetScrnX(SrXc)-xw)>SgXb) then xn:=GetScrnX(SrXc)-xw-1;
      if ((GetScrnY(SrYc)-yw)>SgYb) then yn:=GetScrnY(SrYc)  + 1;
      if (xn=-20648) then xn:=SgXb  + 1;
      if (yn=-20648) then yn:=SgYe-yw-1;

      z1:=SrXs*Trunc(SrXb/SrXs);
      while (z1<SrXe) do
       begin
        TextOut(GetScrnX(z1)-(xw div 2), yn, FunStr(z1,4,2));
        z1:=z1+SrXs;
       end;

      z1:=SrYs*Trunc(SrYb/SrYs);
      while (z1<SrYe) do
       begin
        if (abs(z1-SrYc)>(SrYs/SgYs/2)) then
          TextOut(xn, GetScrnY(z1)-(yw div 2), FunStr(z1,4,2));
        z1:=z1+SrYs;
       end;
     end;

   end;
end;


//   .
procedure IniDrawPar;
 begin
 //     .
  SrXb:= FunVal (fmMnForm.meSrXb.Text);  SrYb:= FunVal (fmMnForm.meSrYb.Text);
  SrXe:= FunVal (fmMnForm.meSrXe.Text);  SrYe:= FunVal (fmMnForm.meSrYe.Text);
  SrXc:= FunVal (fmMnForm.meSrXc.Text);  SrYc:= FunVal (fmMnForm.meSrYc.Text);
  SrXs:= FunVal (fmMnForm.meSrXs.Text);  SrYs:= FunVal (fmMnForm.meSrYs.Text);
  SgXs:=StrToInt(fmMnForm.meSgXs.Text);  SgYs:=StrToInt(fmMnForm.meSgYs.Text);

 //   .
  with fmMnForm, pbDrawAr, Canvas do
   begin
    SgXl:=Width-1;     SgYl:=Height-1;
    SgXb:=Left+1;      SgYb:=Top+1;
    SgXe:=SgXb+SgXl-1; SgYe:=SgYb+SgYl-1;
   end;
  SrXl:=SrXe-SrXb;     SrYl:=SrYe-SrYb;
 end;

end.