unit UnOptim1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, Menus, StdCtrls, Buttons, Mask,
  math, Spin,                                  //  
  UnGraph, UnDraw, UnGrid, UnDefin, UnMinim;   //  
//{$include .pas }

type
  TfmMnForm = class(TForm)

    pcMnPage: TPageControl;
    tsParam: TTabSheet;
    tsGfxPar: TTabSheet;
    tsDraw: TTabSheet;

    mmMnMenu: TMainMenu;
    mmuFile: TMenuItem;
     mmdFemp1: TMenuItem;
     mmdFexit: TMenuItem;
    mmuWork: TMenuItem;
    mmuHelp: TMenuItem;
     mmdHabpr: TMenuItem;
     mmdHemp1: TMenuItem;
     mmdHemp2: TMenuItem;
     mmdHabau: TMenuItem;

    sbMessag: TStatusBar;
    tmTimer: TTimer;
    pbDrawAr: TPaintBox;
    pnButton: TPanel;
     bbDrMpCl: TBitBtn;
     bbDrMpLL: TBitBtn;
     pbColMap: TPaintBox;
     imMexMat: TImage;

    gbLstSet: TGroupBox;
     lbEquat: TLabel;
     coEquat: TComboBox;
     lbFill: TLabel;
     coFill: TComboBox;
     lbLevel: TLabel;
     coLevel: TComboBox;
    gbDrwPar: TGroupBox;
    gbWhatDr: TGroupBox;
    gbBegPar: TGroupBox;
    meSrXb: TMaskEdit;
    meSrXe: TMaskEdit;
    meSrYb: TMaskEdit;
    meSrYe: TMaskEdit;
    meSrXc: TMaskEdit;
    meSrYc: TMaskEdit;
    meSrXs: TMaskEdit;
    meSrYs: TMaskEdit;
    meSgXs: TMaskEdit;
    meSgYs: TMaskEdit;
    lbSrXbe: TLabel;
    lbSrYbe: TLabel;
    lbSrXYc: TLabel;
    lbSrXYs: TLabel;
    lbSgXYs: TLabel;
    lbWkSzXY: TLabel;
    bbDrGrid: TBitBtn;
    meWkSzX: TMaskEdit;
    meWkSzY: TMaskEdit;
    bbIterat: TBitBtn;
    gbColors: TGroupBox;
    seDiColR: TSpinEdit;
    seDiColB: TSpinEdit;
    seDiColG: TSpinEdit;
    seDiNmCl: TSpinEdit;
    lbColors: TLabel;
    pbDiClEx: TPaintBox;
    lbScoCol: TLabel;
    seScoGrd: TSpinEdit;
    cbTrnpLL: TCheckBox;
    lbBegXYr: TLabel;
    meBeg_Xr: TMaskEdit;
    meBeg_Yr: TMaskEdit;
    coMetOpt: TComboBox;
    lbMetOpt: TLabel;
    lbCnsEps: TLabel;
    lbCnsHst: TLabel;
    lbCnsUoo: TLabel;
    meCnsEps: TMaskEdit;
    meCnsHst: TMaskEdit;
    meCnsUoo: TMaskEdit;
    gbTraceF: TGroupBox;
    lbTraceX: TLabel;
    lbTraceY: TLabel;
    lbTraceZ: TLabel;
    tsReport: TTabSheet;
    mmOtchet: TMemo;
    cbDrSmal: TCheckBox;
    cbDrAxis: TCheckBox;
    cbDrBig: TCheckBox;
    cbDrNumb: TCheckBox;
    lbTimFrm: TLabel;
    seTimFrm: TSpinEdit;
    bbStopIt: TBitBtn;
    gbPrLeLi: TGroupBox;
    lbStLeLi: TLabel;
    lbWdLeLi: TLabel;
    meStLeLi: TMaskEdit;
    meWdLeLi: TMaskEdit;

    procedure mmdFexitClick(Sender: TObject);
    procedure bbDrMpClClick(Sender: TObject);
    procedure bbDrMpLLClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pbDrawArPaint(Sender: TObject);
    procedure tsDrawResize(Sender: TObject);
    procedure pbColMapPaint(Sender: TObject);
    procedure coEquatChange(Sender: TObject);
    procedure meSrXbChange(Sender: TObject);
    procedure meSrXeChange(Sender: TObject);
    procedure meSrYbChange(Sender: TObject);
    procedure meSrYeChange(Sender: TObject);
    procedure meSrXcChange(Sender: TObject);
    procedure meSrYcChange(Sender: TObject);
    procedure meSrXsChange(Sender: TObject);
    procedure meSrYsChange(Sender: TObject);
    procedure meSgXsChange(Sender: TObject);
    procedure meSgYsChange(Sender: TObject);
    procedure meWkSzXChange(Sender: TObject);
    procedure meWkSzYChange(Sender: TObject);
    procedure bbIteratClick(Sender: TObject);
    procedure seDiNmClChange(Sender: TObject);
    procedure pbDiClExPaint(Sender: TObject);
    procedure seDiColRChange(Sender: TObject);
    procedure seDiColGChange(Sender: TObject);
    procedure seDiColBChange(Sender: TObject);
    procedure bbDrGridClick(Sender: TObject);
    procedure tmTimerTimer(Sender: TObject);
    procedure bbStopItClick(Sender: TObject);
    procedure pbDrawArMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


  procedure ScrToBuf; //     .
  procedure BufToScr; //     .
  procedure OneIter(i:Integer); //    .


const
  Nmax = 1;                            // - .
  flDraw : Boolean = False ;           //  
  flStop : Boolean = False ;           //  


type
  Dim  = 1..Nmax;                      //  ().
  Vect = array [Dim] of Extended;      // Nmax- .
  NVect= ^Vect;                        //   .

var
  fmMnForm : TfmMnForm;                //   
//kill  zVal : NVect;                        //   
  DrawArea: TBitmap;                   //    
  ToRect, FromRect: TRect;             // -   
  xScor, yScor:Integer;

implementation

{$R *.DFM}


{ ---=====             =====--- }


//     .
procedure ScrToBuf;
 begin
  DrawArea:=TBitmap.Create;
  ToRect.Left:=0;
  ToRect.Top:=0;
  with fmMnForm, pbDrawAr, Canvas do
   begin
    ToRect.Right:=Width;
    ToRect.Bottom:=Height;
   end;
  FromRect:=ToRect;
  with DrawArea, Canvas do
   begin
    Width:=ToRect.Right;
    Height:=ToRect.Bottom;
   end;
  DrawArea.Canvas.CopyRect(ToRect,fmMnForm.pbDrawAr.Canvas,FromRect);
 end;


//     .
procedure BufToScr;
 begin
  fmMnForm.pbDrawAr.Canvas.CopyRect(ToRect,DrawArea.Canvas,FromRect);
FwcsDrawGrid(False,False,False,False);
 end;


{ ---=====          =====--- }


{    }
procedure TfmMnForm.FormCreate(Sender: TObject);
var
  Fil: TextFile;
  i  : Integer;
begin
  coEquat.ItemIndex := 1;
  coFill.ItemIndex  := 0;
  coLevel.ItemIndex := 0;
  coMetOpt.ItemIndex:= 0;

//kill  GetMem(zVal,4096*4096*Sizeof(Extended));
  ScrToBuf; //     .

  AssignFile(Fil, 'Palitr10.dat');
  Reset(Fil);
  for i:=0 to fclScore do
   begin
    ReadLn(Fil, DiColRGB[i,1], DiColRGB[i,2], DiColRGB[i,3]);
    DiColRGB[i,0]:=DiColRGB[i,1]+256*DiColRGB[i,2]+65536*DiColRGB[i,3];
   end;
  CloseFile(Fil);
  seDiNmCl.Value:=0; //    
end;


{    }
procedure TfmMnForm.mmdFexitClick(Sender: TObject);
begin
  Close;
end;


//  [  ]
procedure TfmMnForm.bbDrMpClClick(Sender: TObject);
begin
  flStop:=False; //  
  if (flDraw=False) then CalcAlFn;
  pcMnPage.ActivePage  := tsDraw;
  DrColMap(coFill.ItemIndex);
  ScrToBuf; //     .
end;


//  [ ]
procedure TfmMnForm.bbDrMpLLClick(Sender: TObject);
begin
  flStop:=False; //  
  if (flDraw=False) then CalcAlFn;
  pcMnPage.ActivePage  := tsDraw;
  DrLinLev(coLevel.ItemIndex);
  ScrToBuf; //     .
end;


//  [ ]
procedure TfmMnForm.bbDrGridClick(Sender: TObject);
begin
  flStop:=False; //  
  pcMnPage.ActivePage  := tsDraw;
  FwcsDrawGrid(cbDrSmal.Checked,
               cbDrBig.Checked,
               cbDrAxis.Checked,
               cbDrNumb.Checked);
  ScrToBuf; //     .
end;


//  []
procedure TfmMnForm.bbStopItClick(Sender: TObject);
begin
  flStop:=True; //  "!"
end;


//  [ ]
procedure TfmMnForm.bbIteratClick(Sender: TObject);
var
  i:LongInt;
begin
  flStop:=False; //  
  pcMnPage.ActivePage  := tsDraw;
  DrMinPoi; //  "" 
  Iterat;   // ,     .
  ScrToBuf; //     .

  if (seTimFrm.Value>0) then
   begin
    CurTrace:=1;           //   
    tmTimer.Interval := seTimFrm.Value; //  
    tmTimer.Enabled:=True; //    .
   end
  else
   begin
    for i:=1 to MaxTrace do  OneIter(i);
    ScrToBuf; //     .
   end;
end;


{   }
procedure TfmMnForm.tmTimerTimer(Sender: TObject);
begin
  if (CurTrace<=MaxTrace) then
   begin
    OneIter(CurTrace);
    ScrToBuf; //     .
    Inc(CurTrace);
    if (flStop) then tmTimer.Enabled:=False;
   end
  else  tmTimer.Enabled:=False;  //  .
end;


//    .
procedure OneIter(i:Integer);
var
  gx,gy:Integer;
begin
 with fmMnForm, pbDrawAr, Canvas do  begin
  Pen.Color   := DiColRGB[fclTracI,0];
  Brush.Color := DiColRGB[fclTracP,0];
  gx:=GetScrnX(Solut[i,1]);  gy:=GetScrnY(Solut[i,2]);
  Ellipse(gx-4,gy-4,gx+5,gy+5);//:=DiColRGB[fclTrace,0];
  if (i>1) then
   begin
    MoveTo(GetScrnX(Solut[i-1,1]),GetScrnY(Solut[i-1,2]));
    LineTo(gx,gy);
    MoveTo(gx,gy);
    LineTo(GetScrnX(Solut[i-1,1]),GetScrnY(Solut[i-1,2]));
   end;
  StatusBr('  #'+IntToStr(i)+'  '+IntToStr(MaxTrace));
 end; // with
end;


{    }
procedure TfmMnForm.pbColMapPaint(Sender: TObject);
begin
  DiColMap;
end;


{    }
procedure TfmMnForm.pbDrawArPaint(Sender: TObject);
begin
  BufToScr; //     .
end;


{    }
procedure TfmMnForm.tsDrawResize(Sender: TObject);
begin
  flDraw:=False;     //   .
  with fmMnForm, pbDrawAr, Canvas do
   begin
    xScor:=Width-2;  yScor:=Height-2;
    meWkSzX.Text:=IntToStr(Width);
    meWkSzY.Text:=IntToStr(Height);
   end;
end;


{   }
procedure TfmMnForm.coEquatChange(Sender: TObject);
begin
  flDraw:=False;     //   .
  Fun:=Jn[coEquat.ItemIndex];  //  
end;

procedure TfmMnForm.meSrXbChange(Sender: TObject);
begin
  flDraw:=False;     //   .
end;

procedure TfmMnForm.meSrXeChange(Sender: TObject);
begin
  flDraw:=False;     //   .
end;

procedure TfmMnForm.meSrYbChange(Sender: TObject);
begin
  flDraw:=False;     //   .
end;

procedure TfmMnForm.meSrYeChange(Sender: TObject);
begin
  flDraw:=False;     //   .
end;

procedure TfmMnForm.meSrXcChange(Sender: TObject);
begin
  flDraw:=False;     //   .
end;

procedure TfmMnForm.meSrYcChange(Sender: TObject);
begin
  flDraw:=False;     //   .
end;

procedure TfmMnForm.meSrXsChange(Sender: TObject);
begin
  flDraw:=False;     //   .
end;

procedure TfmMnForm.meSrYsChange(Sender: TObject);
begin
  flDraw:=False;     //   .
end;

procedure TfmMnForm.meSgXsChange(Sender: TObject);
begin
  flDraw:=False;     //   .
end;

procedure TfmMnForm.meSgYsChange(Sender: TObject);
begin
  flDraw:=False;     //   .
end;

procedure TfmMnForm.meWkSzXChange(Sender: TObject);
begin
  flDraw:=False;     //   .
end;

procedure TfmMnForm.meWkSzYChange(Sender: TObject);
begin
  flDraw:=False;     //   .
end;


{     }
procedure TfmMnForm.seDiNmClChange(Sender: TObject);
var
  i:Integer;
begin
  i:=seDiNmCl.Value;
  seDiColR.Value:=DiColRGB[i,1];
  seDiColG.Value:=DiColRGB[i,2];
  seDiColB.Value:=DiColRGB[i,3];
  pbDiClExPaint(Sender)
end;


{    }
procedure TfmMnForm.pbDiClExPaint(Sender: TObject);
begin
   with fmMnForm, pbDiClEx, Canvas do
   begin
    Pen.Color   := DiColRGB[fclContL,0];
    Brush.Color := DiColRGB[seDiNmCl.Value,0];
    Rectangle(0, 0, Width, Height);
   end;
  DiColMap;

end;


{  R- }
procedure TfmMnForm.seDiColRChange(Sender: TObject);
var
  i:Integer;
begin
  i:=seDiNmCl.Value;
  DiColRGB[i,1]:=seDiColR.Value;
  DiColRGB[i,0]:=DiColRGB[i,1]+256*DiColRGB[i,2]+65536*DiColRGB[i,3];
  pbDiClExPaint(Sender)
end;


{  G- }
procedure TfmMnForm.seDiColGChange(Sender: TObject);
var
  i:Integer;
begin
  i:=seDiNmCl.Value;
  DiColRGB[i,2]:=seDiColG.Value;
  DiColRGB[i,0]:=DiColRGB[i,1]+256*DiColRGB[i,2]+65536*DiColRGB[i,3];
  pbDiClExPaint(Sender)
end;


{  B- }
procedure TfmMnForm.seDiColBChange(Sender: TObject);
var
  i:Integer;
begin
  i:=seDiNmCl.Value;
  DiColRGB[i,3]:=seDiColB.Value;
  DiColRGB[i,0]:=DiColRGB[i,1]+256*DiColRGB[i,2]+65536*DiColRGB[i,3];
  pbDiClExPaint(Sender);
end;


//    .
procedure TfmMnForm.pbDrawArMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  with fmMnForm, pbDrawAr, Canvas do
   begin
    lbTraceX.Caption:='x='+FloatToStr(xmin+(X-1)*(xmax-xmin)/(xScor-1));
    lbTraceY.Caption:='y='+FloatToStr(ymax+(Y-1)*(ymin-ymax)/(yScor-1));
    if ( (X>0) and (Y>0) and (X<Width-1) and (Y<Height-1) ) then
      lbTraceZ.Caption:='z='+FloatToStr( FunValIJ(X,Y) )
     else lbTraceZ.Caption:='Out of range';
   end;
end;

end.
